.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

INCLUDE \masm32\INCLUDE\windows.inc
INCLUDE \masm32\INCLUDE\kernel32.inc
INCLUDE \masm32\include\msvcrt.inc
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\msvcrt.lib

.DATA

    dwArgC    DWORD 0
    pArgV     DWORD 0   ; pointer
    pEnv      DWORD 0   ; pointer
    bWildCard DWORD 0
    pszItem   DWORD 0   ; pointer
    StartInfo STARTUPINFO <>
    
.CONST
    szArg    BYTE "arg(%u) = ",0
    szPrompt BYTE 13,10,"Press any key to exit ... ",0
    szCrLf   BYTE 13,10,0

.CODE

  start:

    INVOKE crt___getmainargs, ADDR dwArgC, ADDR pArgV, ADDR pEnv, bWildCard, ADDR StartInfo
    ; pArgV is a pointer to an array of pointers.
    ;  Each pointer points to an individual command-line argument.
    ; dwArgC is the number of individual command-line arguments.
    ;  The dwArgC parameter is always greater than or equal to 1.
    ; pEnv is a pointer to an array of pointers.
    ;  Each pointer in the array points to an individual environment variable.
    ;  A NULL pointer signals the end of the array of pointers.
    ; bWildCard is a boolean value controlling whether the command line
    ;   will be globbed (e.g. *.* expanded to be all files in the startup
    ;   directory).
    ; StartInfo is a pointer to a STARTUPINFO structure.
    
    xor ecx, ecx
  @@:
    push ecx
    mov eax, pArgV
    mov edx, [eax+ecx*4]
    mov pszItem, edx
    ;inc ecx
    INVOKE crt_printf, ADDR szArg, ecx
    INVOKE crt_printf, pszItem
    INVOKE crt_printf, ADDR szCrLf
    pop ecx
    inc ecx
    cmp ecx, dwArgC
    jb @B

    ; WaitKey
    INVOKE crt_printf, ADDR szPrompt
    INVOKE crt__getch
    .IF (eax == 0) || (eax == 0E0h)
        INVOKE crt__getch
    .ENDIF 
    INVOKE crt_printf, ADDR szCrLf

    INVOKE ExitProcess, 0

END start
